Package com.smartgwt.client.widgets

# Class FiscalCalendar

java.lang.Object
com.smartgwt.client.core.JsObject
com.smartgwt.client.core.DataClass
com.smartgwt.client.core.RefDataClass
com.smartgwt.client.widgets.FiscalCalendar

All Implemented Interfaces:
  `HasHandlers`

public class FiscalCalendar extends RefDataClass
An object representing the start date for fiscal years in the current locale.

A fiscal year spans a configurable date range - it may not exactly match a calendar year in length and it can start on any date within the calendar year and potentially end in the next calendar year.

Developers may specify explicit fiscal year start dates by adding `FiscalYear` objects to the `fiscal years array`. If none are provided, or if there is no entry for the given year, one is manufactured based on the default `month` and `date`.

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.core.RefDataClass

  `id`

  ### Fields inherited from class com.smartgwt.client.core.DataClass

  `factoryCreated, factoryProperties`

  ### Fields inherited from class com.smartgwt.client.core.JsObject

  `jsObj`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FiscalCalendar()`
  `FiscalCalendar(int defaultMonth, int defaultDate)`
  `FiscalCalendar(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Integer`
  `getDefaultDate()`
  The default one-based day-number in the `specified month` to use for calculating fiscal dates when no `fiscal years` are provided.
  `Integer`
  `getDefaultMonth()`
  The default zero-based month-number to use for calculating fiscal dates when no `fiscal years` are provided.
  `FiscalYearMode`
  `getDefaultYearMode()`
  This attribute controls how the displayed fiscalYear value should be calculated for dates falling within a period not explicitly listed in the `fiscal years array`.
  `FiscalYear[]`
  `getFiscalYears()`
  An array of `FiscalYear objects` which each represent the start date of a single fiscal year.
  `static FiscalCalendar`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `FiscalCalendar`
  `setDefaultDate(Integer defaultDate)`
  The default one-based day-number in the `specified month` to use for calculating fiscal dates when no `fiscal years` are provided.
  `FiscalCalendar`
  `setDefaultMonth(Integer defaultMonth)`
  The default zero-based month-number to use for calculating fiscal dates when no `fiscal years` are provided.
  `FiscalCalendar`
  `setDefaultYearMode(FiscalYearMode defaultYearMode)`
  This attribute controls how the displayed fiscalYear value should be calculated for dates falling within a period not explicitly listed in the `fiscal years array`.
  `FiscalCalendar`
  `setFiscalYears(FiscalYear... fiscalYears)`
  An array of `FiscalYear objects` which each represent the start date of a single fiscal year.

  ### Methods inherited from class com.smartgwt.client.core.RefDataClass

  `getRef, getRef, internalSetID`

  ### Methods inherited from class com.smartgwt.client.core.DataClass

  `applyFactoryProperties, doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, isFactoryCreated, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated`

  ### Methods inherited from class com.smartgwt.client.core.JsObject

  `equals, getJsObj, hashCode, isCreated, setJavaScriptObject, setJsObj`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### FiscalCalendar

    public FiscalCalendar()

  - ### FiscalCalendar

    public FiscalCalendar(JavaScriptObject jsObj)

  - ### FiscalCalendar

    public FiscalCalendar(int defaultMonth, int defaultDate)

- ## Method Details

  - ### getOrCreateRef

    public static FiscalCalendar getOrCreateRef(JavaScriptObject jsObj)

  - ### setDefaultDate

    public FiscalCalendar setDefaultDate(Integer defaultDate)
    The default one-based day-number in the `specified month` to use for calculating fiscal dates when no `fiscal years` are provided. This value together with `defaultMonth` will be used as the start date for the fiscal years where no explicitly specified fiscalYear configuration is present.
    See also `defaultYearMode`.
    Parameters:
      `defaultDate` - New defaultDate value. Default value is null
    Returns:
      `FiscalCalendar` instance, for chaining setter calls

  - ### getDefaultDate

    public Integer getDefaultDate()
    The default one-based day-number in the `specified month` to use for calculating fiscal dates when no `fiscal years` are provided. This value together with `defaultMonth` will be used as the start date for the fiscal years where no explicitly specified fiscalYear configuration is present.
    See also `defaultYearMode`.
    Returns:
      Current defaultDate value. Default value is null

  - ### setDefaultMonth

    public FiscalCalendar setDefaultMonth(Integer defaultMonth)
    The default zero-based month-number to use for calculating fiscal dates when no `fiscal years` are provided. This value together with `defaultDate` will be used as the start date for the fiscal years where no explicitly specified fiscalYear configuration is present.
    See also `defaultYearMode`.
    Parameters:
      `defaultMonth` - New defaultMonth value. Default value is null
    Returns:
      `FiscalCalendar` instance, for chaining setter calls

  - ### getDefaultMonth

    public Integer getDefaultMonth()
    The default zero-based month-number to use for calculating fiscal dates when no `fiscal years` are provided. This value together with `defaultDate` will be used as the start date for the fiscal years where no explicitly specified fiscalYear configuration is present.
    See also `defaultYearMode`.
    Returns:
      Current defaultMonth value. Default value is null

  - ### setDefaultYearMode

    public FiscalCalendar setDefaultYearMode(FiscalYearMode defaultYearMode)
    This attribute controls how the displayed fiscalYear value should be calculated for dates falling within a period not explicitly listed in the `fiscal years array`.

    The `defaultMonth` and `defaultDate` will be used to calculate the start of the fiscal year period. The defaultYearMode determines whether the reported fiscalYear for this period matches the year in which the period starts or the year in which it ends (so whether a fiscal year spanning dates within both 2020 and 2021 is reported as fiscalYear 2020 or 2021).

    Parameters:
      `defaultYearMode` - New defaultYearMode value. Default value is "end"
    Returns:
      `FiscalCalendar` instance, for chaining setter calls

  - ### getDefaultYearMode

    public FiscalYearMode getDefaultYearMode()
    This attribute controls how the displayed fiscalYear value should be calculated for dates falling within a period not explicitly listed in the `fiscal years array`.

    The `defaultMonth` and `defaultDate` will be used to calculate the start of the fiscal year period. The defaultYearMode determines whether the reported fiscalYear for this period matches the year in which the period starts or the year in which it ends (so whether a fiscal year spanning dates within both 2020 and 2021 is reported as fiscalYear 2020 or 2021).

    Returns:
      Current defaultYearMode value. Default value is "end"

  - ### setFiscalYears

    public FiscalCalendar setFiscalYears(FiscalYear... fiscalYears)
    An array of `FiscalYear objects` which each represent the start date of a single fiscal year.
    Parameters:
      `fiscalYears` - New fiscalYears value. Default value is null
    Returns:
      `FiscalCalendar` instance, for chaining setter calls

  - ### getFiscalYears

    public FiscalYear[] getFiscalYears()
    An array of `FiscalYear objects` which each represent the start date of a single fiscal year.
    Returns:
      Current fiscalYears value. Default value is null